ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.13 by root, Fri Dec 10 10:44:20 2010 UTC vs.
Revision 1.25 by root, Tue Dec 28 18:03:47 2010 UTC

2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10MKBUNDLE="$STATICPERL/mkbundle"
11
12# perl build variables 10# perl build variables
13PERL_PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
14PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
41export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
42 42
43# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
44# required by mkbundle 44# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
46 46
52postconfigure() { : ; } 52postconfigure() { : ; }
53postbuild() { : ; } 53postbuild() { : ; }
54postinstall() { : ; } 54postinstall() { : ; }
55 55
56# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
57[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
58[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
59[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
60 64
61############################################################################# 65#############################################################################
62# support 66# support
63 67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
64unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
65export LC_ALL=C # just to be on the safe side 72LC_ALL=C; export LC_ALL # just to be on the safe side
66 73
67# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
68VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
69$VERSION=0.9 76$VERSION=0.92
70 77
71BZ2=bz2 78BZ2=bz2
72BZIP2=bzip2 79BZIP2=bzip2
73 80
74fatal() { 81fatal() {
107############################################################################# 114#############################################################################
108# clean 115# clean
109 116
110distclean() { 117distclean() {
111 verblock <<EOF 118 verblock <<EOF
112deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
113EOF 120EOF
114 121
115 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
116} 123}
117 124
118############################################################################# 125#############################################################################
119# download/configure/compile/install perl 126# download/configure/compile/install perl
120 127
121clean() { 128clean() {
122 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
131
132realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
123} 136}
124 137
125fetch() { 138fetch() {
126 rcd "$STATICPERL" 139 rcd "$STATICPERL"
127 140
139perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
140trying $URL 153trying $URL
141EOF 154EOF
142 155
143 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
145 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
146 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
147 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
148 fi 162 fi
149 163
150 verblock <<EOF 164 verblock <<EOF
151unpacking perl 165unpacking perl
152EOF 166EOF
153 167
154 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
155 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
156 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
157 chmod -R u+w unpack/perl-$PERL_VERSION 172 chmod -R u+w unpack/perl-$PERL_VERSION
158 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
159 rmdir -p unpack 174 rmdir -p unpack
161} 176}
162 177
163# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
164sedreplace() { 179sedreplace() {
165 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
166 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
167} 209}
168 210
169configure() { 211configure() {
170 fetch 212 fetch
171 213
177configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
178EOF 220EOF
179 221
180 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
181 223
182 make distclean >/dev/null 2>&1 224 "$MAKE" distclean >/dev/null 2>&1
183 225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
184 # I hate them 228 # I hate them for this
185 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
186 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
187 231
188 preconfigure 232 preconfigure
189 233
193 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
194 -Uusedl \ 238 -Uusedl \
195 -Uusethreads \ 239 -Uusethreads \
196 -Uuseithreads \ 240 -Uuseithreads \
197 -Uusemultiplicity \ 241 -Uusemultiplicity \
198 -Duseperlio \
199 -Uusesfio \ 242 -Uusesfio \
200 -Uuseshrplib \ 243 -Uuseshrplib \
201 -Dcppflags="$PERL_CPPFLAGS" \ 244 -A ccflags=" $PERL_CCFLAGS" \
202 -Dccflags="-g2 -fno-strict-aliasing" \ 245 -Dcc="$PERL_CC" \
203 -Doptimize="$PERL_OPTIMIZE" \ 246 -Doptimize="$PERL_OPTIMIZE" \
204 -Dldflags="$PERL_LDFLAGS" \ 247 -Dldflags="$PERL_LDFLAGS" \
205 -Dlibs="$PERL_LIBS" \ 248 -Dlibs="$PERL_LIBS" \
206 -Dprefix="$PERL_PREFIX" \ 249 -Dprefix="$PERL_PREFIX" \
207 -Dbin="$PERL_PREFIX/bin" \ 250 -Dbin="$PERL_PREFIX/bin" \
208 -Dprivlib="$PERL_PREFIX/lib" \ 251 -Dprivlib="$PERL_PREFIX/lib" \
209 -Darchlib="$PERL_PREFIX/lib" \ 252 -Darchlib="$PERL_PREFIX/lib" \
210 -Uusevendorprefix \ 253 -Uusevendorprefix \
211 -Dsitelib="$PERL_PREFIX/lib" \ 254 -Dsitelib="$PERL_PREFIX/lib" \
212 -Dsitearch="$PERL_PREFIX/lib" \ 255 -Dsitearch="$PERL_PREFIX/lib" \
213 -Usitelibexp \
214 -Uman1dir \ 256 -Uman1dir \
215 -Uman3dir \ 257 -Uman3dir \
216 -Usiteman1dir \ 258 -Usiteman1dir \
217 -Usiteman3dir \ 259 -Usiteman3dir \
218 -Dpager=/usr/bin/less \ 260 -Dpager=/usr/bin/less \
219 -Demail="$EMAIL" \ 261 -Demail="$EMAIL" \
220 -Dcf_email="$EMAIL" \ 262 -Dcf_email="$EMAIL" \
221 -Dcf_by="$EMAIL" \ 263 -Dcf_by="$EMAIL" \
222 $PERL_CONFIGURE \ 264 $PERL_CONFIGURE \
265 -Duseperlio \
223 -dE || fatal "Configure failed" 266 -dE || configure_failure
224 267
225 sedreplace ' 268 sedreplace '
226 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 269 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
227 s/ *-fno-stack-protector */ /g 270 s/ *-fno-stack-protector */ /g
228 ' config.sh 271 ' config.sh
243building $STATICPERL/src/perl-$PERL_VERSION 286building $STATICPERL/src/perl-$PERL_VERSION
244EOF 287EOF
245 288
246 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
247 290
248 make || fatal "make: error while building perl" 291 "$MAKE" || fatal "make: error while building perl"
249 292
250 postbuild || fatal "postbuild hook failed" 293 postbuild || fatal "postbuild hook failed"
251} 294}
252 295
253install() { 296install() {
257 verblock <<EOF 300 verblock <<EOF
258installing $STATICPERL/src/perl-$PERL_VERSION 301installing $STATICPERL/src/perl-$PERL_VERSION
259to $PERL_PREFIX 302to $PERL_PREFIX
260EOF 303EOF
261 304
262 rm -rf "$PERL_PREFIX" 305 ln -sf "perl/bin/" "$STATICPERL/bin"
263 306 ln -sf "perl/lib/" "$STATICPERL/lib"
307
308 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
309 rm -rf "$PERL_PREFIX" # by this rm -rf
310
264 make install || fatal "make install: error while installing" 311 "$MAKE" install || fatal "make install: error while installing"
265 312
266 rcd "$PERL_PREFIX" 313 rcd "$PERL_PREFIX"
267 314
268 # create a "make install" replacement for CPAN 315 # create a "make install" replacement for CPAN
269 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 316 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
270make || exit 317"$MAKE" || exit
271 318
272if find blib/arch/auto -type f | grep -q -v .exists; then 319if find blib/arch/auto -type f | grep -q -v .exists; then
273 echo Probably an XS module, rebuilding perl 320 echo Probably an XS module, rebuilding perl
274 if make perl; then 321 if "$MAKE" perl; then
275 mv perl "$PERL_PREFIX"/bin/perl 322 mv perl "$PERL_PREFIX"/bin/perl~ \
323 && rm -f "$PERL_PREFIX"/bin/perl \
324 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
276 make -f Makefile.aperl map_clean 325 "$MAKE" -f Makefile.aperl map_clean
277 else 326 else
278 make -f Makefile.aperl map_clean 327 "$MAKE" -f Makefile.aperl map_clean
279 exit 1 328 exit 1
280 fi 329 fi
281fi 330fi
282 331
283make install UNINST=1 332"$MAKE" install UNINST=1
284EOF 333EOF
285 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 334 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
286 335
287 # trick CPAN into avoiding ~/.cpan completely 336 # trick CPAN into avoiding ~/.cpan completely
288 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 337 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
348 for mod in "$@"; do 397 for mod in "$@"; do
349 echo 398 echo
350 echo $mod 399 echo $mod
351 ( 400 (
352 rcd $mod 401 rcd $mod
353 make -f Makefile.aperl map_clean >/dev/null 2>&1 402 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
354 make distclean >/dev/null 2>&1 403 "$MAKE" distclean >/dev/null 2>&1
355 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 404 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
356 make || fatal "$mod: error building module" 405 "$MAKE" || fatal "$mod: error building module"
357 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 406 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
358 make distclean >/dev/null 2>&1 407 "$MAKE" distclean >/dev/null 2>&1
359 exit 0 408 exit 0
360 ) || exit $? 409 ) || exit $?
361 done 410 done
362} 411}
363 412
364############################################################################# 413#############################################################################
365# main 414# main
366 415
367podusage() { 416podusage() {
368 echo 417 echo
418
369 if [ -e "$PERL_PREFIX/bin/perl" ]; then 419 if [ -e "$PERL_PREFIX/bin/perl" ]; then
370 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 420 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
371 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 421 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
372 2>/dev/null && exit 422 2>/dev/null && exit
373 fi 423 fi
424
374 # try whatever perl we can find 425 # try whatever perl we can find
375 perl -MPod::Usage -e \ 426 perl -MPod::Usage -e \
376 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 427 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
377 2>/dev/null && exit 428 2>/dev/null && exit
378 429
379 fatal "displaying documentation requires a working perl - try '$0 install' first" 430 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
380} 431}
381 432
382usage() { 433usage() {
383 podusage 0 434 podusage 0
384} 435}
406 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 457 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
407 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create" 458 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
408 459
409 command="${1#--}"; shift 460 command="${1#--}"; shift
410 case "$command" in 461 case "$command" in
462 version )
463 echo "staticperl version $VERSION"
464 ;;
411 fetch | configure | build | install | clean | distclean) 465 fetch | configure | build | install | clean | realclean | distclean)
412 verblock <<EOF
413$command
414EOF
415 ( "$command" ) 466 ( "$command" ) || exit
416 ;; 467 ;;
417 instsrc ) 468 instsrc )
418 ( instsrc "$@" ) 469 ( instsrc "$@" ) || exit
419 exit 470 exit
420 ;; 471 ;;
421 instcpan ) 472 instcpan )
422 ( instcpan "$@" ) 473 ( instcpan "$@" ) || exit
423 exit 474 exit
424 ;; 475 ;;
425 cpan ) 476 cpan )
426 ( install ) 477 ( install ) || exit
427 "$PERL_PREFIX/bin/cpan" "$@" 478 "$PERL_PREFIX/bin/cpan" "$@"
428 exit 479 exit
429 ;; 480 ;;
430 mkbundle ) 481 mkbundle )
431 ( install ) 482 ( install ) || exit
432 bundle "$@" 483 bundle "$@"
433 exit 484 exit
434 ;; 485 ;;
435 mkperl ) 486 mkperl )
436 ( install ) 487 ( install ) || exit
437 bundle --perl "$@" 488 bundle --perl "$@"
438 exit 489 exit
439 ;; 490 ;;
440 mkapp ) 491 mkapp )
441 ( install ) 492 ( install ) || exit
442 bundle --app "$@" 493 bundle --app "$@"
443 exit 494 exit
444 ;; 495 ;;
445 help ) 496 help )
446 podusage 2 497 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines